#!/usr/bin/python
# -*- coding: UTF-8 -*-
"""
@author:andrew
@file:train_set_visual.py
@email:admin@marques22.com
@email:2021022362@m.scnu.edu.cn
@time:2022/10/15
@description: 检查数据集是否按照预期处理
"""
import numpy as np
from matplotlib import pyplot as plt
from tqdm import tqdm

plt.rcParams['font.sans-serif'] = ['SimHei']  # 用来正常显示中文标签
plt.rcParams['axes.unicode_minus'] = False  # 用来正常显示负号


fig = plt.figure(figsize=(10, 2), dpi=200)
plt.tight_layout()


def visual_segment(one, save_dir):
    save_dir.mkdir(exist_ok=True, parents=True)
    one = [two.cpu().numpy() for two in one]
    segment, stft, label_type, PN, segmentNo, label_type, new_label, SP, EP = one
    print("drawing sample")
    for i in tqdm(range(len(one[0]) if len(one[0]) < 128 else 128)):
        plt.clf()
        plt.plot(np.linspace(SP[i], EP[i], len(segment[i][0])), segment[i][0])
        plt.title(f"sampNo:{PN[i]} label_type:{label_type[i]} {SP[i]}:{EP[i]}")
        plt.xlabel("时间 秒")
        plt.ylabel("心晓信号幅值")
        plt.tight_layout()
        plt.savefig(save_dir / f"sampNo {PN[i]} {SP[i]} {EP[i]} label_type {label_type[i]}")


if __name__ == '__main__':
    pass
